Program Trans;
{Uses Crt;}
Const MaxLeng = 4096;
      FNameIn = 'Matr.In'; FNameRes = 'Matr.avt'; FNameOut = 'Matr.Out';
Type T_Matr = Array [1..2,1..2] of Longint;
     T_StrM = Array [1..MaxLeng] Of Char;
Var InpM, OutM, TempM : T_Matr;
    Move, MoveA, MoveU : T_StrM;
    I, J, MoveM, MoveMA, MoveMU : Word;
    NameIn, NameRes, NameOut, TmpStr : String;
    Manual, Quit, YesA, YesU, Correct, Correct_1 : Boolean;
    YesStudent : Boolean;
    Ch : Char;
    FOut : Text;

Procedure ReadInp (NameIn : String; Var InpM, OutM : T_Matr);
Var Fin : Text;
Begin
  Assign(Fin, NameIn); ReSet(Fin);
  ReadLn(Fin, InpM[1,1], InpM[1,2]);
  ReadLn(Fin, InpM[2,1], InpM[2,2]);
  ReadLn(Fin, OutM[1,1], OutM[1,2]);
  ReadLn(Fin, OutM[2,1], OutM[2,2]);
  Close(Fin)
End;

Procedure ReadOut(NameOut : String;
		   Var Move: T_StrM; Var MoveM : Word; Var Yes : Boolean);
Var Fin : Text;
    Ans : String;
    I : Word;
    Error : Boolean;
Begin
  Assign(Fin, NameOut); ReSet(Fin);
  ReadLn(Fin, Ans);
  I := 0; While I < Length(Ans) Do Begin Inc(I); Ans[I]:=UpCase(Ans[I]) End{While};
  I := Pos (' ', Ans); If I <> 0 Then Delete(Ans, I, Length(Ans));
  Yes := Ans = 'YES';
  If Yes Then Begin
       I := 0;
       While (Not EoLn(Fin)) And (I<MaxLeng) Do Begin Inc(I); Read(Fin, Move[I]) End;
       MoveM := I;
     End{Yes}
   Else
     If Ans <> 'NO'Then Begin
     { Error  ******************************}
     End{<>NO};
  Close(Fin)
End;


Procedure L (InpM : T_Matr; Var OutM : T_Matr);
Begin
 OutM := InpM; OutM[1,1] :=  OutM[1,1] - InpM[2,1]; OutM[1,2] :=  OutM[1,2] - InpM[2,2];
End{L};

Procedure R (InpM : T_Matr; Var OutM : T_Matr);
Begin
 OutM := InpM; OutM[1,1]:=OutM[1,1]+InpM[2,1]; OutM[1,2]:=OutM[1,2]+InpM[2,2];
End{L};

Procedure S (InpM : T_Matr; Var OutM : T_Matr);
Begin
 OutM[1,1]:=InpM[2,1]; OutM[1,2]:=InpM[2,2];  OutM[2,1]:=InpM[1,1]; OutM[2,2]:=InpM[1,2];
End{L};

Procedure OutScreen(A : T_Matr; Move : T_StrM; MoveM : Word);
Var I : Word;
Begin
  WriteLn(A[1,1] : 5, A[1,2] : 5);
  WriteLn(A[2,1] : 5, A[2,2] : 5);
  Write('>>'); For I :=1 To MoveM Do Write(Move[i]); WriteLn;
End;

Procedure OneMove(MoveC : Char ; Var OutM : T_Matr);
Begin
    Case MoveC Of
       'S' : S(OutM, OutM);
       'L' : L(OutM, OutM);
       'R' : R(OutM, OutM);
    End{Case}
End;

Procedure Translator(Var OutM : T_Matr; Move : T_StrM; MoveM : Word);
Var I : Word;
Begin
   For I := 1 To MoveM Do OneMove(Move[I], OutM);
End;

Function EQ (A, B : T_Matr) : Boolean;
Begin
  Eq := (A[1,1] = B[1,1]) And (A[1,2] = B[1,2]) And (A[2,1] = B[2,1]) And (A[2,2] = B[2,2])
End{EQ};

Begin
   Manual :=  False;

   Case ParamCount Of
   0 : Begin
	  WriteLn('ThisProgram Input.Data Autor.Data Student.Data');
	  NameIn:=FNameIn; NameRes:=FNameRes; NameOut:='MANUAL';
       End{0};
   1 : Begin
	 Manual := True;
	 NameIn  := ParamStr(1);
	 NameRes:=FNameRes; NameOut:='MANUAL';
	End{1};
   2 : Begin
	 Manual := True;
	 NameIn  := ParamStr(1);
	 TmpStr := ParamStr(2);
	 For I:=1 To Length(TmpStr) Do TmpStr[i] := UpCase(TmpStr[i]);
	 If TmpStr = 'MANUAL' Then Begin
	   NameRes:=Copy(NameIn, 1, Pos('.', NameIn))+'Res';
	 End;
	 NameOut:='MANUAL';
       End{2};
   3 : Begin
	 NameIn  := ParamStr(1);
	 NameRes := ParamStr(2);
	 NameOut := ParamStr(3);
       End{2};
 End{Case};
 If Manual Then Begin
   {ClrScr;}
   ReadInp (NameIn, InpM, OutM); TempM := InpM;
   Quit := False;  MoveM:=0;
   OutScreen(TempM, Move, MoveM );
   Repeat
     ReadLn(Ch);
{     Ch := UpCase(ReadKey);
     If Ch = #0 Then Ch := ReadKey
      Else }Begin
	Case Ch Of
	   #27 : Quit := True;
	   'S', 'R', 'L' : Begin
		  Inc(MoveM); Move[MoveM] := Ch;
		  OneMove(Ch, TempM)
		 End{SRL}
	   Else Write(^G);
	End{Case};
	OutScreen(TempM, Move, MoveM );
      End{Else}
   Until Quit;
  Assign(FOut, NameRes); ReWrite(FOut);
  WriteLn(FOut, 'YES');
  For I:=1 To MoveM Do Write(FOut, Move[I]); WriteLn(FOut);
  Close(Fout);
 End{Manual}
 Else Begin {Auto}
   For I:=1 To Length(NameOut) Do NameOut[i] := UpCase(NameOut[i]);
   If NameOut = 'CALC' Then Begin
       ReadInp(NameIn, InpM, OutM); TempM := InpM;
       ReadOut(NameRes, MoveA, MoveMA, YesA );
       For I:=1 To MoveMA Do OneMove(MoveA[i], TempM);
       Assign(FOut, NameIn+'_'); ReWrite(FOut);
	 WriteLn(Fout, InpM[1,1], ' ',InpM[1,2]);
	 WriteLn(Fout, InpM[2,1], ' ',InpM[2,2]);
	 WriteLn(Fout, TempM[1,1], ' ',TempM[1,2]);
	 WriteLn(Fout, TempM[2,1], ' ',TempM[2,2]);
       Close(FOut)
   End{Calc}
   Else Begin
      ReadInp(NameIn, InpM, OutM); TempM := InpM;
      ReadOut(NameOut, MoveU, MoveMU, YesU );
      ReadOut(NameRes, MoveA, MoveMA, YesA );
      Correct_1 := YesA =YesU;
      {YesAutora = YesStudent}
      If Correct_1 Then Begin
	If  Yesu Then Begin
	   For I:=1 To MoveMU Do OneMove(MoveU[i], TempM);
	   Correct := Eq(TempM, OutM);
	   {YesAutora = YesStudent, MoveStudents Do Not result }
	   If Correct Then WriteLn('You Win')
	   { Ok for MoveStudent
	   *****************************};
	  End{YesStudent}
	  Else Begin Correct := True; WriteLn('You Win') End; {Ok for NoStudent}
       End{Correct};
      If Not (Correct And Correct_1) Then  Begin
	WriteLn('You Less')
       { Error *****************************};
       End{NotCorrect};
  End {Test}
 End{Auto};


End.